package ms.itsecteam.warpdrink.data;

import android.util.Log;
import java.util.Arrays;
import java.util.List;
import java.util.ListIterator;

import ms.itsecteam.warpdrink.MainActivity;
import ms.itsecteam.warpdrink.data.objects.User;
import ms.itsecteam.warpdrink.data.rest.RestClient;

public class DataApi {

    private static DataApi instance;
    private MainActivity mainActivity;
    private DataApi () {}

    public static DataApi getInstance () {
        if (DataApi.instance == null) {
            DataApi.instance = new DataApi();
        }
        return DataApi.instance;
    }

    public MainActivity getMainActivity() {
        return mainActivity;
    }

    public void setMainActivity(MainActivity mainActivity) {
        this.mainActivity = mainActivity;
    }

    public boolean addUser(String name) {
        if(User.getByName(name) == null) {
            User u = new User();
            u.setName(name);
            RestClient.getInstance().createUser(u);
            //u.save();
            refreshUserData();
            return true;
        }
        return false;
    }

    public void refreshUserData() {
        List<User> u = RestClient.getInstance().getAllUser();
        if(u == null)
            return;
        User.deleteAll();
        ListIterator<User> ui = u.listIterator();
        while(ui.hasNext()) {
            ui.next().save();
        }
        Log.d("App", Arrays.toString(u.toArray()));
        mainActivity.refreshUsers();
    }


    public User remoteGetUser(int userid) {
        return RestClient.getInstance().getUser(userid);
    }
}
