package ms.itsecteam.warpdrink.data.rest;

import android.util.Log;

import com.google.gson.Gson;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import ms.itsecteam.warpdrink.MainActivity;
import ms.itsecteam.warpdrink.data.objects.User;
import ms.itsecteam.warpdrink.data.rest.http.HttpGetRequest;
import ms.itsecteam.warpdrink.data.rest.http.HttpPostRequest;
import ms.itsecteam.warpdrink.data.rest.http.HttpPutRequest;

public class RestClient {

    private static RestClient instance;
    private MainActivity mainActivity;
    private RestClient() {}

    public static RestClient getInstance () {
        if (RestClient.instance == null) {
            RestClient.instance = new RestClient();
        }
        return RestClient.instance;
    }

    public User getUser(int userid) {
        try {
            User u = (User) new RequestSingleObject<User>().initTask("user/"+userid,User.class).execute().get();
            Log.d("TV",u.getName());
            return u;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
    public List<User> getAllUser() {
        try {
            String response = new HttpGetRequest().initTask("user/all").execute().get();
            return Arrays.asList(new Gson().fromJson(response, User[].class));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
    public void saveUserCredit(User u) {
        List<NameValuePair> postParams = new ArrayList<NameValuePair>(2);
        postParams.add(new BasicNameValuePair("credit", String.valueOf(u.getCredit())));
        new HttpPostRequest().initTask("/user/"+u.getUserid(),postParams).execute();
    }
    public boolean createUser(User u) {
        List<NameValuePair> postParams = new ArrayList<NameValuePair>(2);
        postParams.add(new BasicNameValuePair("name", u.getName()));
        try {
            String response = new HttpPutRequest().initTask("/user/create",postParams).execute().get();
            if(response != "") {
                u = new Gson().fromJson(response, User.class);
                if(u.getUserid() != 0) {
                    u.save();
                    return true;
                }
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }
}

